Subject: Can Programming Be Liberated from the von Neumann Style? A Functional Style and Its Algebra of Programs
From: "John W. Backus" <[email-masked]>
To: Alan Turing <[email-masked]>
Date: Mon, 17 Oct 1977 12:00:00 -0700

Conventional programming languages are growing ever more enormous, but not 
stronger. Inherent defects at the most basic level cause them to be both 
fat and weak: their primitive word-at-a-time style of programming inherited 
from their common ancestor--the von Neumann computer, their close coupling 
of semantics to state transitions, their division of programming into a 
world of expressions and a world of statements, their inability to 
effectively use powerful combining forms for building new programs from 
existing ones, and their lack of useful mathematical properties for 
reasoning about 
programs.